// HyperPlayPenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HyperPlayPen.h"
#include "HyperPlayPenDlg.h"
#include "HyperPlayPenHook.h"
#include "PolyDraw.h"
#include "winuser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int g_iKeys = 0;
bool g_bSoundOn = true;

UINT nPreviousScreenSaverState = 0;

const char *g_szRegistryPath_c = "Software\\SteamingCoffee.com\\Hyper PlayPen";

/////////////////////////////////////////////////////////////////////////////
// CHyperPlayPenDlg dialog


CHyperPlayPenDlg::CHyperPlayPenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHyperPlayPenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHyperPlayPenDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

   // Disables most task switching for Win95/98
   SystemParametersInfo(SPI_SETSCREENSAVERRUNNING, TRUE, &nPreviousScreenSaverState, 0);

   DisableTaskKeys(true);
}

CHyperPlayPenDlg::~CHyperPlayPenDlg()
{
   // Enables task switching again for Win95/98
   SystemParametersInfo(SPI_SETSCREENSAVERRUNNING, FALSE, &nPreviousScreenSaverState, 0);

   DisableTaskKeys(false);
}

void CHyperPlayPenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHyperPlayPenDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHyperPlayPenDlg, CDialog)
	//{{AFX_MSG_MAP(CHyperPlayPenDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_KEYDOWN()
	ON_WM_CLOSE()
	ON_WM_MOUSEMOVE()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// This function may or may not beep
void RandBeep()
{
   const int iMaxHertz = 32767;
   const int iMinHertz = 37;

   int iHertz = (lRandom()%(iMaxHertz-iMinHertz));
   iHertz += iMinHertz;

   ::Beep(iHertz, 40);
}

/////////////////////////////////////////////////////////////////////////////
// CHyperPlayPenDlg message handlers

BOOL CHyperPlayPenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   MoveWindow(-10, -10, GetSystemMetrics(SM_CXFULLSCREEN)+100, GetSystemMetrics(SM_CYFULLSCREEN)+100);

   PostMessage(WM_KEYDOWN, UINT(-1));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHyperPlayPenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHyperPlayPenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void HandleKey(HWND hTargetWnd)
{
   DrawRandPoly(hTargetWnd);
   if (g_bSoundOn)
      RandBeep();

   g_iKeys++;
   if (g_iKeys % 50 == 0) // every 50 keys, clear screen
   {
       ClearScreen(hTargetWnd);
   }
}

void CHyperPlayPenDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
   if(GetKeyState(VK_CONTROL) < 0 &&
      GetKeyState(VK_MENU) < 0 &&
      GetKeyState(VK_SHIFT) >= 0)
   {
      if(nChar == VK_F8)
      {
         CRegKey vKey;
         if(vKey.Create(HKEY_LOCAL_MACHINE, g_szRegistryPath_c) == ERROR_SUCCESS)
         {
            DWORD dwSoundOn = (DWORD)(g_bSoundOn ? 1 : 0);
            vKey.SetValue(dwSoundOn, "Sound");
            vKey.Close();
         }
         
         DestroyWindow();
      }
      else if (nChar == VK_F4)
      {
         g_bSoundOn = !g_bSoundOn;  
      }
   }

   if (nChar == UINT(-1))
      ClearScreen(m_hWnd);
   else
   {
      if(nChar == VK_DELETE)
         ClearScreen(m_hWnd);

      HandleKey(m_hWnd);
   }
}

void CHyperPlayPenDlg::OnClose() 
{
}

void CHyperPlayPenDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
}

BOOL CHyperPlayPenDlg::PreTranslateMessage(MSG* pMsg) 
{
    if (pMsg->message == WM_KEYDOWN && (pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_RETURN))
    {
        return TRUE;
    }

	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CHyperPlayPenDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
    return TRUE;
}
