#include "StdAfx.h"
#include "HyperPlayPen.h"
#include "HyperPlayPenDlg.h"

HHOOK g_hHookKbd = NULL; // std hook used for Win95/98 to disable Ctrl+Break
HHOOK g_hHookKbdLowLevel = NULL; // low-level hook used for 2000/XP+

__declspec(dllexport)LRESULT CALLBACK MyTaskKeyHookLowLevel(int nCode, WPARAM wp, LPARAM lp)
{
	KBDLLHOOKSTRUCT *pkh = (KBDLLHOOKSTRUCT *) lp;

	if (nCode == HC_ACTION)
    {
		BOOL bCtrlKeyDown = GetAsyncKeyState(VK_CONTROL)>>((sizeof(SHORT) * 8) - 1);

		if ((pkh->vkCode==VK_ESCAPE && bCtrlKeyDown) ||				    // Ctrl+Esc
			 (pkh->vkCode==VK_TAB && pkh->flags & LLKHF_ALTDOWN) ||     // Alt+TAB
			 (pkh->vkCode==VK_ESCAPE && pkh->flags & LLKHF_ALTDOWN)||   // Alt+Esc
			 (pkh->vkCode==VK_LWIN || pkh->vkCode==VK_RWIN) ||          // Start Menu
          (pkh->vkCode==VK_CANCEL))
      {
			return 1; // go directly to jail, do not pass go, do not collect $200
		}
	}
	return CallNextHookEx(g_hHookKbdLowLevel, nCode, wp, lp);
}

__declspec(dllexport)LRESULT CALLBACK MyTaskKeyHook(int code, WPARAM wParam, LPARAM lParam)
{
   //disable Ctrl+Break for Windows 95/98 -- other keys disabled with SystemParametersInfo(SPI_SETSCREENSAVERRUNNING)
   if (wParam == VK_CANCEL)
   {
      return TRUE;
   }

	return CallNextHookEx(g_hHookKbd, code, wParam, lParam);
}

__declspec(dllexport) BOOL DisableTaskKeys(BOOL bDisable)
{
	if (bDisable)
   {
		if (!g_hHookKbdLowLevel)
			g_hHookKbdLowLevel = SetWindowsHookEx(WH_KEYBOARD_LL, MyTaskKeyHookLowLevel, theApp.m_hInstance, GetCurrentThreadId());
		if (!g_hHookKbd)
			g_hHookKbd = SetWindowsHookEx(WH_KEYBOARD, MyTaskKeyHook, theApp.m_hInstance, GetCurrentThreadId());
   } 
   else 
   {
      if (g_hHookKbdLowLevel != NULL)
      {
         UnhookWindowsHookEx(g_hHookKbdLowLevel);
         g_hHookKbdLowLevel = NULL;
	   }
   }

	return TRUE;
}
